import 'package:flutter/material.dart';

class BtnBootstrap extends StatelessWidget {
  final Function onPressed;
  final String text;
  final Color color;
  final double fontSize;
  final Color backgroundColor;
  final bool hasIcon;
  final IconData icon;
  final bool autoRoundIt;
  final double radius;
  final Color hoverColor;
  final Color fillColor;
  final bool autoColorIt;
  final dynamic button;

  const BtnBootstrap({
    @required this.button,
    @required this.onPressed,
    this.text = 'text?',
    this.color = kColorConstrast,
    this.fontSize,
    this.backgroundColor,
    this.hasIcon = false,
    this.icon,
    this.radius = 0,
    this.autoRoundIt = false,
    this.hoverColor,
    this.fillColor,
    this.autoColorIt = true,
  });

  @override
  Widget build(BuildContext context) {
    return MaterialButton(
      onPressed: onPressed,
      hoverColor: autoColorIt
          ? button.isValid
              ? kColorPrimary.shade400
              : kColorPrimary.shade300
          : hoverColor,
      color: autoColorIt
          ? button.isValid
              ? kColorPrimary.shade600
              : null
          : backgroundColor,
      child: hasIcon
          ? Icon(
              icon,
              color: color,
            )
          : Text(
              text,
              style: TextStyle(
                color: color,
                fontSize: fontSize,
              ),
            ),
      shape: RoundedRectangleBorder(
        borderRadius: autoRoundIt
            ? BorderRadius.circular(20)
            : BorderRadius.circular(radius),
      ),
    );
  }
}

const dynamic kColorPrimary = Colors.purple;
const dynamic kColorSecondary = Colors.green;
const dynamic kColorConstrast = Colors.white;
